//Follow us on other social media

//https://www.youtube.com/c/ZinTechIdeas
//https://www.facebook.com/zin.techideas.3
//https://www.instagram.com/zintechideas/
//https://twitter.com/Zintechideas
//https://zintechideas.ir/
#include <ESP8266WebServer.h>
#include <Wire.h>
#include <SPI.h>
#include <Adafruit_BMP280.h>
 
Adafruit_BMP280 bmp;
 
float temperature, pressure, altitude;
 
/*Put your SSID & Password*/
const char* ssid = "Inserisci il nole della tua rete (SSID)";
const char* password = "Inserisci la password per la tua rete WiFi";
 
ESP8266WebServer server(80);              
  
void setup() {
  Serial.begin(115200);
  Serial.flush();
  Wire.pins(0, 2);
  Wire.begin(0, 2);
  delay(100);
   
  bmp.begin(0x76);   
 
  Serial.println("Connecting to ");
  Serial.println(ssid);
 
  //connect to your local wi-fi network
  WiFi.begin(ssid, password);
 
  //check wi-fi is connected to wi-fi network
  while (WiFi.status() != WL_CONNECTED) {
  delay(1000);
  Serial.print(".");
  }
  Serial.println("");
  Serial.println("WiFi connected..!");
  Serial.print("Got IP: ");  Serial.println(WiFi.localIP());
 
  server.on("/", handle_OnConnect);
  server.onNotFound(handle_NotFound);
 
  server.begin();
  Serial.println("HTTP server started");
  bmp.setSampling(Adafruit_BMP280::MODE_NORMAL,
                  Adafruit_BMP280::SAMPLING_X2,
                  Adafruit_BMP280::SAMPLING_X16,
                  Adafruit_BMP280::FILTER_X16,
                  Adafruit_BMP280::STANDBY_MS_500);
 
}
void loop() {
  server.handleClient();}
  void handle_OnConnect() {
  temperature = bmp.readTemperature();
  pressure = bmp.readPressure() / 100.0F;
  altitude = bmp.readAltitude(1013.25);
  server.send(200, "text/html", SendHTML(temperature,pressure,altitude));   
}

void handle_NotFound(){
  server.send(404, "text/plain", "Not found");
}
String SendHTML(float temperature,float pressure,float altitude){
  String ptr = "<!DOCTYPE html> <html>\n";
  ptr +="<head><meta http-equiv=\"refresh\" content=\"2\">\n";
  ptr +="<title>ESP8266 Weather Station</title>\n"; 
  ptr +="<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}\n";
  ptr +="body{margin-top: 50px;} h1 {color: #444444;margin: 50px auto 30px;}\n";
  ptr +="p {font-size: 24px;color: #444444;margin-bottom: 10px;}\n";
  ptr +="</style>\n";
  ptr +="</head>\n";
  ptr +="<body>\n";
  ptr +="<div id=\"webpage\">\n";
  ptr +="<h1>ESP8266 Weather Station</h1>\n";
  ptr +="<p>Temperature: ";
  ptr +=temperature;
  ptr +="&deg;C</p>";
  ptr +="<p>Pressure: ";
  ptr +=pressure;
  ptr +="hPa</p>";
  ptr +="<p>Altitude: ";
  ptr +=altitude;
  ptr +="m</p>";
  ptr +="</div>\n";
  ptr +="</body>\n";
  ptr +="</html>\n";

  Serial.print("Temperature = ");
  Serial.print(temperature);
  Serial.print(" °C  |  ");
  // 2: print pressure
  Serial.print("Pressure = ");
  Serial.print(pressure);
  Serial.print(" hPa |  ");
  // 3: print altitude
  Serial.print("Approx Altitude = ");  
  Serial.print(altitude);
  Serial.println(" slm");

    return ptr;
}
